----------------------------------------------------------------------------
-- @Author: ViperGTS96------------------------------------------------------
----------------------------------------------------------------------------
--------------------"The simplest design is the best design." --------------
----------------------------------------------------------------------------
----------------------------------------------------------------------------
fireworks = {};
local modDescFile = loadXMLFile("modDesc", g_currentModDirectory .. "modDesc.xml");
fireworks.dir = g_currentModDirectory;
fireworks.file = fireworks.dir.."tracers.i3d"
fireworks.title = getXMLString(modDescFile, "modDesc.title.en");
fireworks.author = getXMLString(modDescFile, "modDesc.author");
fireworks.version = getXMLString(modDescFile, "modDesc.version");
fireworks.inputsXML = getUserProfileAppPath().. "inputBinding.xml";
fireworks.modifierKey = Input.KEY_rshift;
fireworks.accessorKey = Input.KEY_l;
fireworks.stopperKey = Input.KEY_k;
fireworks.tracerIndex = 0;
fireworks.tracerTypes = 7;
fireworks.setPostion = {0,0,0};
fireworks.mainShot = {0,0,0};
fireworks.mainShotRot = {0,0,0};
fireworks.mainShotHeight = math.random(75.0,90.0); --meters
fireworks.mainShotSpeed = 0.3; --meters
fireworks.mainShotDone = false;
fireworks.colorCycle = 8; --Start with Rainbow (max colors+1)
fireworks.rotations = {};
fireworks.rotations.x=0;
fireworks.rotations.y=0;
fireworks.rotations.yDone = false;
fireworks.rotations.xDone = false;
fireworks.rotations.increment = 10.0;
fireworks.rotations.atomStar = false;
fireworks.rotations.ringStar = false;
fireworks.delay = 20.0; --frames
fireworks.reFireDelay = 0; --frames
fireworks.breakFromReFire = false;
fireworks.maxDistance = math.random(16,20); --meters
fireworks.speed = fireworks.maxDistance / 160;--0.1;--0.075; --meters
fireworks.active = false;
fireworks.soundsPlayed = 0;

delete(modDescFile);

addModEventListener(fireworks);

function fireworks:loadSounds(fire_works,i)
	fire_works.whistleSound = createSample("whistle"..i);
	fire_works.zipSound = createSample("zip"..i);
	fire_works.popSound = createSample("pop"..i);
	fire_works.crackleSound = createSample("crackle"..i);
	loadSample(fire_works.whistleSound, fireworks.dir.."sounds/whistle.ogg", false);
	loadSample(fire_works.zipSound, fireworks.dir.."sounds/zip.ogg", false);
	loadSample(fire_works.popSound, fireworks.dir.."sounds/pop.ogg", false);
	loadSample(fire_works.crackleSound, fireworks.dir.."sounds/crackles.ogg", false);
end;

function fireworks:loadMap(savegame)
	fireworks.file = loadI3DFile(fireworks.file, false, false, false);
	print("Load mod: "..fireworks.title.." : v"..fireworks.version.." by "..fireworks.author);
end;

function fireworks:update(dt)
	if Input.isKeyPressed(fireworks.modifierKey) then
		if Input.isKeyPressed(fireworks.accessorKey) and not fireworks.active then
			fireworks.breakFromReFire = false;
			fireworks.setPostion = {0,0,0};
			fireworks.active = true;
			print("Launching Fireworks");
		elseif Input.isKeyPressed(fireworks.stopperKey) and not fireworks.breakFromReFire then
			fireworks.breakFromReFire = true;
			print("Fireworks refiring halted");
		end;
	end;
	if fireworks.active then
		if g_currentMission.fire_works == nil or #g_currentMission.fire_works <=0 then
			if fireworks.breakFromReFire then
				fireworks.active = false;
				return;
			end;
			g_currentMission.fire_works = {};
			for i=1, math.floor(math.random(1,10)) do
				local function deepCopy(original)
					local copy = {}
					for k, v in pairs(original) do
						if type(v) == "table" then
							v = deepCopy(v);
						end;
						copy[k] = v;
					end;
					return copy;
				end;
				local clone = deepCopy(fireworks);
				table.insert(g_currentMission.fire_works,clone);
			end;
			fireworks.largeCount = 0;
		end;
		local deleteIndex;
		--local fireworksCount = #g_currentMission.fire_works;
		for i, fire_works in pairs(g_currentMission.fire_works) do
			if fire_works ~= nil and fire_works.nodes == nil then
				fire_works:loadSounds(fire_works,i)
				fire_works.mainShotHeight = math.random(75.0,90.0);
				fire_works.maxDistance = math.random(16,20);
				fire_works.colorCycle = math.floor(math.random(0,8));
				local starType = math.random(0,10);
				--[[if fireworksCount >= 6 then
					if fireworks.largeCount >= 3 then
						starType = math.random(5,10);
					end;
				else / fireworksCount >= 3 and]]
				if  fireworks.largeCount >= 2 then
					starType = math.random(5,10);
				end;
				if starType >= 8 then --8,9,10
					fire_works.rotations.atomStar = true;
					fire_works.rotations.ringStar = false;
					fire_works.maxDistance = fireworks.maxDistance*0.75;
				elseif starType >= 5 then--5,6,7
					fire_works.rotations.ringStar = true;
					fire_works.rotations.atomStar = false;
				else--0,1,2,3,4
					fire_works.rotations.ringStar = false;
					fire_works.rotations.atomStar = false;
					fireworks.largeCount = fireworks.largeCount +1;
				end;
				fire_works.speed = fire_works.maxDistance / 160;
				fire_works.nodes = {};
				fire_works.nodes.childShots = {};
				fire_works.delay = fireworks.delay + (math.floor(math.random(10,20))*i);
			end;
			if fire_works.delay > 0 then
				fire_works.delay = fire_works.delay-1;
			else
				if fire_works.done then
					deleteIndex = i;
					break;
				end;
				if fire_works.mainShotDone then
					if not fire_works.rotations.yDone then
						while not fire_works.rotations.yDone do
							fire_works:setupFireworks(g_currentMission,fire_works);
						end;
					else
						fire_works:explodeFireworks(g_currentMission,fire_works);
					end;
				else
					fire_works:launchFireworks(g_currentMission,fire_works);
				end;
			end;
		end;
		if deleteIndex ~= nil then
			table.remove(g_currentMission.fire_works,deleteIndex);
		end;
	end;
end;

function fireworks:nextRotation(rot)
	if not rot.xDone then 
		if rot.x < 350 then
			rot.x = rot.x + rot.increment;
		else
			rot.xDone = true;
			rot.x = 0;
			if rot.ringStar then rot.yDone = true; end;
		end;
	else		
		if rot.y < 350 then
			local increment = rot.increment;
			if rot.atomStar then
				increment = 180.0;
			end;
			rot.y = rot.y + increment;
			rot.xDone = false;
		else
			rot.yDone = true;
			rot.y = 0;
		end;
	end;
end;

function fireworks:checkXZRotation(rot)

	local rotateParent = false;
	local x = rot.x;

	if rot.x < 45.0 then
		rotateParent = true;
		x = rot.x + 45.0;
	elseif (rot.x > 135.0 and rot.x < 225.0) then
		x = rot.x + 90.0;
		rotateParent = true;	
	elseif rot.x > 275.0 then
		x = rot.x - 45.0;
		rotateParent = true;
	end;
	--[[local var1 = rot.x <= 45.0;
		local var2 = rot.x >= 135.0 and rot.x <= 225.0;
		local var3 = rot.x >= 275.0;
		if not (var1 and var2 and var3) then
			x = 0; -- Tire Shape
		end;
	end;]]
	return x, rotateParent;

end;


function fireworks:launchFireworks(mapRef,fire_works)

	if mapRef.player ~= nil then
		if fire_works.nodes.mainShot == nil then
			local x,y,z = unpack(fireworks.setPostion);
			if x == 0 then
				if y == 0 and z == 0 then
					x,y,z = localToWorld(mapRef.player.cameraNode,0,0,-10);
					y = getTerrainHeightAtWorldPos(mapRef.terrainRootNode, x,y,z)
					fireworks.setPostion = {x,y,z};
				end;
			end;
			local index = fire_works.colorCycle;
			if index >= 8 then
				index = math.floor(math.random(0,fireworks.tracerTypes));
			end;
			local node = getChildAt(fireworks.file, 0);
			fire_works.nodes.mainShot = clone(node, false, false, false);
			fire_works.nodes.mainShot = getChildAt(fire_works.nodes.mainShot, index);
			link(mapRef.terrainRootNode, fire_works.nodes.mainShot);
			setWorldTranslation(fire_works.nodes.mainShot,x,y,z);
			setRotation(getChildAt(fire_works.nodes.mainShot,0),math.rad(math.random(-35.0,35.0)),math.rad(math.random(0.0,359.0)),0);
		else
			if not fire_works.mainShotDone then
				local anchorPoint = getChildAt(fire_works.nodes.mainShot,0);
				local _,y,_ = getTranslation(getChildAt(anchorPoint, 0));
				if y < fire_works.mainShotHeight then
					setTranslation(getChildAt(anchorPoint, 0),0,y+fire_works.mainShotSpeed,0);
					if y > fire_works.mainShotHeight/12 then
						fire_works:playSound(1,fire_works);
					end;
				else	--Main Shot Done
					--if getVisibility(mapRef.fireworks.mainShot) then
					setVisibility(fire_works.nodes.mainShot, false);
					--end;
					fire_works.mainShot = {getWorldTranslation(getChildAt(anchorPoint,0))};
					fire_works.mainShotRot = {math.random(0,359),math.random(0,359),math.random(0,359)};
					fire_works.mainShotDone = true;
					fire_works:playSound(2,fire_works);
				end;
			end;
		end;
	end;

end;

function fireworks:setupFireworks(mapRef,fire_works)

	local i = 0;
	if fire_works.colorCycle ~=8 then
		i = fire_works.colorCycle;
	else
		i = fire_works.tracerIndex;
	end;

	local node = getChildAt(fireworks.file, 0);
	fire_works.nodes.childShots[#fire_works.nodes.childShots+1] = clone(node, false, false, false);
	local index = #fire_works.nodes.childShots;
	fire_works.nodes.childShots[index] = getChildAt(fire_works.nodes.childShots[index], i);
	link(mapRef.terrainRootNode, fire_works.nodes.childShots[index]);
	setWorldTranslation(fire_works.nodes.childShots[index], unpack(fire_works.mainShot));
	fire_works:nextRotation(fire_works.rotations);
	setWorldRotation(fire_works.nodes.childShots[index], unpack(fire_works.mainShotRot));
	if fire_works.rotations.atomStar or fire_works.rotations.ringStar then
		setRotation(getChildAt(fire_works.nodes.childShots[index],0), fire_works.rotations.x, fire_works.rotations.y, 0);
	else
		local x, RotateParent = fire_works:checkXZRotation(fire_works.rotations);
		if RotateParent then
			local newParent = createTransformGroup("rotExtenstion");
			link(mapRef.terrainRootNode, newParent);
			setWorldTranslation(newParent, unpack(fire_works.mainShot));
			setWorldRotation(newParent, unpack(fire_works.mainShotRot));
			link(newParent, fire_works.nodes.childShots[index]);
			setTranslation(fire_works.nodes.childShots[index], 0,0,0);
			setRotation(fire_works.nodes.childShots[index], 0, 0, math.rad(-90));
		end;
		setRotation(getChildAt(fire_works.nodes.childShots[index],0), math.rad(x), math.rad(fire_works.rotations.y), 0);
	end;
	if fire_works.tracerIndex >= fire_works.tracerTypes then
		fire_works.tracerIndex = 0;
	else
		fire_works.tracerIndex = fire_works.tracerIndex + 1;
	end;

end;

function fireworks:explodeFireworks(mapRef,fire_works)

	if fire_works.nodes ~= nil and #fire_works.nodes.childShots > 0 then
		for i = 1, #fire_works.nodes.childShots do
			if fire_works.nodes.childShots[i] ~= nil then
				local node = getChildAt(fire_works.nodes.childShots[i],0);
				if node ~= nil then
					node = getChildAt(node,0);
					local _,y,_ = getTranslation(node);
					if y < fire_works.maxDistance then
						local speed = fire_works.speed
						if y > fire_works.maxDistance/2 then
							speed = (fire_works.speed - fire_works.speed*((y-(fire_works.maxDistance/2))/(fire_works.maxDistance/2)))
							if speed <= fire_works.speed/10 then speed = fire_works.speed/10; end;
						end;
						setTranslation(node,0,y+speed,0);
					else
						fire_works:playSound(3,fire_works);
						local tracerScale,_,_ = getScale(node);
						if tracerScale > 0.01 then
							tracerScale = tracerScale - 0.01;
							setScale(node,tracerScale,tracerScale,tracerScale);
						else
							delete(fire_works.nodes.childShots[i]);
							table.remove(fire_works.nodes.childShots, i);
							if #fire_works.nodes.childShots <= 0 then
								delete(fire_works.nodes.mainShot);
								fire_works.done = true;
								-- Finished.
							end;
						end;
					end;
				end;
			end;
		end;
	else
		print("Error fireworks:explodeFireworks");
	end;

end;

function fireworks:playSound(sound, fire_works)
	if sound <= 1 and fire_works.soundsPlayed ~= 1 then
		if isSamplePlaying(fire_works.popSound) then
			stopSample(fire_works.popSound, 0, 0);
		end;
		if isSamplePlaying(fire_works.crackleSound) then
			stopSample(fire_works.crackleSound, 0, 0);
		end;
		if fire_works.rotations.atomStar or fire_works.rotations.ringStar then
			if isSamplePlaying(fire_works.whistleSound) then
				stopSample(fire_works.whistleSound, 0, 0);
			end;
			if not isSamplePlaying(fire_works.zipSound) then
				local volume = 0.4;
				playSample(fire_works.zipSound, 1, volume, 0, 0, 0);
				fire_works.soundsPlayed = 1;
			end;
		else
			if isSamplePlaying(fire_works.zipSound) then
				stopSample(fire_works.zipSound, 0, 0);
			end;
			if not isSamplePlaying(fire_works.whistleSound) then
				local volume = 0.4;
				playSample(fire_works.whistleSound, 1, volume, 0, 0, 0);
				fire_works.soundsPlayed = 1;
			end;		
		end;
	elseif sound == 2 and fire_works.soundsPlayed ~= 2 then	
		if isSamplePlaying(fire_works.zipSound) then
			stopSample(fire_works.zipSound, 0, 0);
		end;
		if isSamplePlaying(fire_works.crackleSound) then
			stopSample(fire_works.crackleSound, 0, 0);
		end;
		if isSamplePlaying(fire_works.whistleSound) then
			stopSample(fire_works.whistleSound, 0, 0);
		end;
		if not isSamplePlaying(fire_works.popSound) then
			local volume = 0.5;
			playSample(fire_works.popSound, 1, volume, 0, 0, 0);
			fire_works.soundsPlayed = 2;
		end;
	elseif sound > 2 and fire_works.soundsPlayed ~= 3 then
		if isSamplePlaying(fire_works.zipSound) then
			stopSample(fire_works.zipSound, 0, 0);
		end;
		if isSamplePlaying(fire_works.popSound) then
			stopSample(fire_works.popSound, 0, 0);
		end;
		if isSamplePlaying(fire_works.whistleSound) then
			stopSample(fire_works.whistleSound, 0, 0);
		end;
		if not isSamplePlaying(fire_works.crackleSound) then
			local volume = 0.6;
			playSample(fire_works.crackleSound, 1, volume, 0, 0, 0);
			fire_works.soundsPlayed = 3;
		end;
	end;
end;